#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <gnome.h>
#include "lokkit.h"

int write_firewall(int policy, int ether, int ether1, int *ports, int dhcp)
{

	int i;
	FILE *fw=fopen(fwscript, "w");
	int num;
	struct in_addr *p;
	char buffer[128];
	
	if(fw==NULL)
		return -1;
	
	fprintf(fw, "#!/bin/sh\n");
	fprintf(fw, "PATH=/sbin:$PATH\n");
	
	fprintf(fw, "ipfwadm -I -f\n");	
	
	for(i=0;i<8;i++)
	{
		if(ports[i])
			fprintf(fw, "ipfwadm -I -i accept -S 0/0 -D 0/0 %d -P tcp -y\n",
				ports[i]);
	}
	
	fprintf(fw, "ipfwadm -I -i accept -S 0/0 -D 0/0 -W lo\n");

	fprintf(fw, "ipfwadm -I -i accept -S 0/0 67:68 -D 0/0 67:68 -W eth0\n");
	fprintf(fw, "ipfwadm -I -i accept -S 0/0 67:68 -D 0/0 67:68 -W eth1\n");
	
	if(ether==0)
		fprintf(fw, "ipfwadm -I -i accept -S 0/0 -D 0/0 -W eth0\n");
	if(ether1==0)
		fprintf(fw, "ipfwadm -I -i accept -S 0/0 -D 0/0 -W eth1\n");

	if(policy==0)
	{
		p=parse_resolv(&num);
		for(i=0;i<num;i++)
		{
			fprintf(fw, "ipfwadm -I -i accept -S %s 53 -D 0/0 -P udp\n",
				inet_ntoa(p[i]));
		}
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 -P tcp -y\n");
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 -P udp\n");
	}
	else
	{
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 0:1023 2049 -P tcp -y\n");
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 0:1023 2049 -P udp\n");
		fprintf(fw, "ipfwadm -I -i deny -S 0/0 -D 0/0 6000:6009 -P tcp -y\n");
	}
	sprintf(buffer, "/bin/sh %s", fwscript);
	system(buffer);
	fclose(fw);
	return 0;
}


void flush_firewall(void)
{
	unlink(fwscript);
	system("/sbin/ipfwadm -I -f");
}

